<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: scaffold.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: scaffold.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>const M = {
  chalk: require("chalk"),
  inquirer: require("inquirer"),
  path: require("path"),
  fs: require("fs")
};

/**
 * The scaffolder that executes JS commands using a `scaffold` array and
 * scripts in a specified directory.
 *
 * ### Example of usage
 *
 * ```
 * let Scaffold = new Scaffold('commands/', scaffolds)
 * let results = Scaffold.run().then( (result) => {
 *  console.log(results);
 *  }
 * ```
 *
 * ### Scaffold Object
 *
 * ```
 * let scaffolds = [
 *   {command: "commandName", value: ["value1", "value2"]}, // &lt;-- Scaffold object
 *   {command: "commandName2", value: "someValue"}          // &lt;-- Scaffold object
 *   …
 * ]
 * ```
 *
 * Note: the `comandName.js` and `commandName2.js` should exists and contain an
 * exported function that will receive the `value`.  The returned value of the
 * scaffold script will be inscribe in the scaffold object in the `result`
 * field.
 *
 * @module scaffold
 * @param {string} dir The directory of the commands (default: "commands/")
 * @param {array} scaffolds The scaffold structure to be executed.
 */
class Scaffold {
  constructor(commandsDir = "commands/") {
    this.commandsDir = M.path.normalize(commandsDir);
  }

  /** Run the initialized scaffolds */
  run(scaffolds = []) {
    const results = {};
    return new Promise((resolve, reject) => {
      scaffolds.forEach(scaffold => {
        scaffold.result = this._executeCommand(
          scaffold.command,
          scaffold.value,
          results,
          reject
        );
        results[scaffold.name] = scaffold;
      });
      resolve(results);
    });
  }

  /**
   * Execute the corresponding command that stands in the specified commands
   * directory.
   *
   * @param {string} command The command to execute (the JS script without the extension).
   * @param {string} value The value to pass to the command that will be executed.
   * @param {object} scaffold The current scaffold structure (useful to check
   * and see if another command was executed or not).
   */
  _executeCommand(command, value, results, reject) {
    let commandPath =
      process.cwd() +
      "/" +
      M.path.normalize(`${this.commandsDir}/${command}.js`);
    let commandModule = undefined;
    if (!M.fs.existsSync(commandPath)) {
      console.log(
        M.chalk.red("ERROR:"),
        `${M.chalk.red(command)} ${commandPath} does not exists in the ${
          this.commandsDir
        } directory`
      );
      return reject(null);
    }
    try {
      commandModule = require(commandPath);
    } catch (e) {
      console.log(
        M.chalk.red("ERROR:"),
        `${M.chalk.red(command)} ${commandPath} returned an error`
      );
      console.error(e);
      return reject(e); // Note: given by the `run` function
    }
    try {
      return commandModule(value, results);
    } catch (e) {
      console.log(e);
      M.chalk.red("ERROR:"),
        `${M.chalk.red(command)} ${commandPath} does not exists in the ${
          this.commandsDir
        } directory`;
    }
  }
}

module.exports = Scaffold;
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-menu.html">menu</a></li><li><a href="module-scaffold.html">scaffold</a></li></ul><h3>Classes</h3><ul><li><a href="Scavader.html">Scavader</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.2</a> on Wed Jun 12 2019 17:39:45 GMT+0100 (GMT+01:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
